// MoI Nodeedit
// Curves v.0.93 - Max Smirnov, 2016
// litegraph.js library (c) Javi Agenjo http://tamats.com

(function () {

///////// Stream2Array Stream points to array////////by r2d3(ralf:-)
function Stream2Array()
{
	this.addInput("In","objectlist");
	this.addInput("Max","numarray");
	this.addOutput("Out","pointarray");

	this.properties = {mode:["Points", "Points"]};
}

pointArray.prototype.shiftPoint = function(ptc)
{
		ptc=Math.abs(Math.round(ptc));
		this.data.splice(0, ptc*7);
		this.xlength-=ptc;
		this.length-=ptc;
}

Stream2Array.title = "Stream2Array";
Stream2Array.desc = "Points to pointarray";
var out = new pointArray();
Stream2Array.prototype.onExecute = function()
{
	var input = this.getInputData(0, moi.geometryDatabase.createObjectList());
	var max = this.getInputData(1, 1);
	if (this.properties.mode[0] === "Points" )
	{
		if(out.length<max){
			var obj = input.getPoints();
			out.pushPoint(obj.item(0).pt);
			}else{
			var ptc=max-out.length+1;
			out.shiftPoint(ptc);
			obj = input.getPoints();
			out.pushPoint(obj.item(0).pt);
			}
	}
	this.setOutputData(0, out);

}

LiteGraph.registerNodeType("r2d3/Stream2Array", Stream2Array);
///////////////////////////
////////////////r2d3
// Variable
function Memory()
{
	this.minsize = [20, 0];
	this.addInput("In","numarray");
	this.addInput("Keep","numarray");
	this.addOutput("out","numarray");
	this.properties = { value:[1] };

}



Memory.title = "Memory";
Memory.desc = "Memory";

 
Memory.prototype.onAdded = function()
{
this.graph.addGlobalOutput(this.id,"myval","numarray");
this.inputs[1].label="set 0 or 1";

}

function getLabel(lb){
	if(!isInt(lb)){
	var label=lb.toFixed(2).toString();
	}else{
	var label=lb.toString();
	}
	return label;
}
function isInt(n) {
   return n % 1 === 0;
}

Memory.prototype.onPropertyChange = function()
{
	var s = this.properties.value.toString();
	this.outputs[0].label = (s.length > 16)?lang.getTranslation("Array")+"("+this.properties.value.length+")":s;
	this.computeSize();
};

Memory.prototype.onExecute = function()
{	
	var inp = this.getInputData(0, new Array());
    var keep=this.getInputData(1, new Array());
    var out = new Array();
    var mem=new Array();
   		if(keep[0]==0){
			out=inp;
			this.graph.setGlobalInputData(this.id,inp);;
			this.setOutputData(0, out);
			this.inputs[0].label="In";
			this.inputs[1].label="Keep=0";
			this.outputs[0].label=getLabel(out[0]);
		}else if(keep[0]==1){
		mem=this.graph.getGlobalInputData(this.id);
			this.inputs[1].label="Keep=1";
			this.setOutputData(0, mem);
			this.outputs[0].label=mem;
			this.inputs[0].label="$:";
		}else if(mem.length>0){
		 this.inputs[1].label="Keep=NaN";
		}else{
		this.outputs[0].label="No value";
		}
}

LiteGraph.registerNodeType("r2d3/Memory", Memory);

///////////////
////////r2d3
    function display()
    {
        this.addInput("In", "numarray");
        this.addOutput("", "numarray");
        
    }

    display.title = "Display";
    display.desc = "Display";
    
    function isInt(n) {
   	return n % 1 === 0;
	}
	
	
    display.prototype.onExecute = function ()
    {
        var inp = this.getInputData(0, new Array());
        var label=[];

		if(inp.length>0){
			for(var i=0;i<inp.length;i++){
				if(!isInt(inp[i])){
				label[i]=inp[i].toFixed(2);
				}else{
				label[i]=inp[i];
				}
			}
		this.inputs[0].label = label.toString();
		this.setOutputData(0, inp);
		}else{
		this.inputs[0].label="NoInput";
		}
    }
    display.prototype.onPropertyChange = function ()
    {

         //      this.outputs[0].label = inp[0].toFixed(2);
        //       this.outputs[1].label = this.bbox.yLength.toFixed(2);
        //       this.outputs[2].label = this.bbox.zLength.toFixed(2);
    }

    LiteGraph.registerNodeType("r2d3/display", display);   
////////////    

// ObjtoArray2
function ObjtoArray2()
{
	this.addInput("In","objectlist");
	this.addOutput("Out","objectlist");
	this.addOutput("Array","pointarray");
	this.properties = {mode:["Points","Points","StartEnd"]};
}

ObjtoArray2.title = "ObjtoArray2";
ObjtoArray2.desc = "Objects to pointarray";

ObjtoArray2.prototype.onExecute = function()
{
	var input = this.getInputData(0, moi.geometryDatabase.createObjectList());
	var out = new pointArray();
	if (this.properties.mode[0] === "Points" )
	{
		var obj = input.getPoints();
		for ( var i = 0; i<obj.length; i++ ) out.pushPoint(obj.item(i).pt);
	}
	if (this.properties.mode[0] === "StartEnd" )
	{
		var obj = input.getCurves();
		for ( var i = 0; i<obj.length; i++ ){ 
		out.pushPoint(obj.item(i).getStartPt());
		out.pushPoint(obj.item(i).getEndPt());
		}
		
	}
	this.setOutputData(0, input);
	this.setOutputData(1, out);
}

LiteGraph.registerNodeType("r2d3/ObjtoArray2", ObjtoArray2);

///////////////
// camera2
function camera2()
{

	this.addInput("camPt","pointarray");
	this.addInput("target","pointarray");
        this.properties = {encoder:"",filePath:"",Width:800,Height:600,save:["Off","Off","On"],idx:0,frames:100};
}

camera2.title = "camera2";
camera2.desc = "camera";

    camera2.prototype.getExtraMenuOptions = function ()
    {
        var that = this;
        return [
            {content: lang.getTranslation("Load"), callback: function () {
                    that.properties.filename = moi.filesystem.getOpenFileName('Choose a CSV file', 'Point files (*.txt, *.csv)|*.txt;*.csv|All files (*.*)|*.*');
                }}
        ];
    }

    camera2.prototype.onAdded = function ()
    {
        if (this.properties.encoder === "")
           this.properties.encoder = moi.filesystem.getOpenFileName('Choose a CSV file', 'Point files (*.txt, *.csv)|*.txt;*.csv|All files (*.*)|*.*');
    }
camera2.prototype.onExecute = function()
{         camPt = new pointArray(false);
          camPt.push(100,100,100,0,0,0,1);
            
        var camPtA = this.getInputData(0, camPt);
        var targetPtA = this.getInputData(1, new pointArray(true));
        var camPt=camPtA.getPoint(0);
        var targetPt=targetPtA.getPoint(0);
        var FiPa=this.properties.filePath;
        var Enc=this.properties.encoder;
        moi.ui.mainWindow.viewpanel.mode="3d";
        var vp=moi.ui.getActiveViewport();
        vp.reset();
        vp.setcameraAndTarget(camPt,targetPt);
        // render the pictures
    if(this.properties.save[0]==="On"&&this.properties.idx<this.properties.frames){
        this.properties.idx+=1;
        var fname="test";
        var adress=this.properties.filePath;adress+=fname;adress+=this.properties.idx;adress+=".png";
        vp.render( this.properties.Width, this.properties.Height).save(adress);
        //make video from pictures
        if(this.properties.idx===this.properties.frames){moi.filesystem.shellExecute(Enc,' -f image2 -pattern_type glob -framerate 24 -i "'+FiPa+fname+'*.png" -s '+this.properties.Width+'x'+this.properties.Height+' -y '+FiPa+fname+'.avi');}
    }

}

camera2.prototype.onAdded = function ()
    {	

    }
LiteGraph.registerNodeType("r2d3/camera2", camera2);

///////////////
// Quartz2
function Quartz2()
{
	this.addInput("Hz","numarray");
	this.addInput("Min","numarray");
	this.addInput("Max","numarray");
	this.addOutput("Out","numarray");
	this.internal = { hz:[0] };
	this.properties = { value:[0], start:[0], end:[360], step:[1], mode:["Cycled", "Cycled", "Tic-tac"]};
	this.local = { starttime:0 };
	this.isImmortal = true;
}

Quartz2.title = "Quartz2";
Quartz2.desc = "Quartz2 clock";

Quartz2.prototype.onAdded = function()
{
	this.onStart();
}

Quartz2.prototype.onStart = function()
{
	this.local.starttime = LiteGraph.getTime();
	this.local.startvalue = this.properties.value[0];
	this.local.startstep = this.properties.step[0];
}

Quartz2.prototype.onPropertyChange = function( property )
{
	if ( this.properties.mode[0] === "Cycled" && (this.properties.end[0]-this.properties.start[0])*this.properties.step[0] < 0) { this.properties.step[0] *= -1 }
	if ( this.properties.start[0] === this.properties.end[0] ) this.properties.end[0] = this.properties.start[0] + this.properties.step[0];
	if ( property === 'mode' ) this.onStart();
}

Quartz2.prototype.onExecute = function()
{
	var hz = this.getInputData(0, [0]);
	var stepsPerCycle;
	var vl = this.properties.value[0];
	this.properties.start = this.getInputData(1, [0]);
	this.properties.end = this.getInputData(2, [0]);
	var start = this.properties.start[0];
	var end = this.properties.end[0];

	var step = this.local.startstep;

	if ( hz[0] !== this.internal.hz[0] ) { this.onStart(); this.internal.hz[0] = hz[0]; }
	if ( hz[0] > 0 )
	{
		if (this.graph.status === LGraph.STATUS_RUNNING)
		{
		 	var time = LiteGraph.getTime() - this.local.starttime;

		 	if (this.properties.mode[0] === "Cycled" )
		 	{
		 		stepsPerCycle = Math.abs((end - start)/step);
		 		vl = this.local.startvalue + Math.floor( (time % (1000/hz[0])) / (1000/hz[0]) * stepsPerCycle ) * step;
		 		if ( end > start ) if ( vl >= end ) { vl = start + (vl - start) % (end - start) }
				if ( end < start ) if ( vl <= start ) { vl = start - (start - vl) % (start - end) }
				this.properties.value[0] = vl;
		 	}
		 	else
		 	{
		 		stepsPerCycle = Math.abs((end - start)/step*2);
		 		var cstep = Math.floor( (time % (1000/hz[0])) / (1000/hz[0]) * stepsPerCycle );
		 		vl = this.local.startvalue;
		 		if ( cstep >= stepsPerCycle/2 )
		 		{
		 			cstep -= stepsPerCycle/2;
		 			step *= -1;
		 			vl = start + end - vl;
		 		}
		 		vl = vl + cstep * step;
		 		if ( end > start )
				{
					if ( vl > end ) { vl = end - (vl - start) % (end - start); step *= -1; }
					if ( vl < start ) { vl = start + (start - vl) % (end - start); step *= -1; }
				}
				else
				{
					if ( vl > start ) { vl = start - (vl - end) % (start - end); step *= -1; }
					if ( vl < end ) { vl = end + (end - vl) % (start - end); step *= -1; }
				}
		 		this.properties.value[0] = vl;
		 		this.properties.step[0] = step;
		 	}
		}
		if (this.graph.status === LGraph.STATUS_STOPPED)
		{
			this.properties.value[0] += step;
			vl = this.properties.value[0];
			if (this.properties.mode[0] === "Cycled" )
			{
				if ( end > start ) if ( vl >= end ) { this.properties.value[0] = start + (vl - start) % (end - start) }
				if ( end < start ) if ( vl <= start ) { this.properties.value[0] = start - (start - vl) % (start - end) }
			}
			else
			{
				if ( end > start )
				{
					if ( vl > end ) { this.properties.value[0] = end - (vl - start) % (end - start); this.properties.step[0] *= -1; }
					if ( vl < start ) { this.properties.value[0] = start + (start - vl) % (end - start); this.properties.step[0] *= -1; }
				}
				else
				{
					if ( vl > start ) { this.properties.value[0] = start - (vl - end) % (start - end); this.properties.step[0] *= -1; }
					if ( vl < end ) { this.properties.value[0] = end + (end - vl) % (start - end); this.properties.step[0] *= -1; }
				}
			}
		}
	}
	this.setOutputData(0, [this.properties.value[0]]);
}

LiteGraph.registerNodeType("r2d3/Quartz2", Quartz2);

})();

