// MoI Nodeedit
// Transform v.0.6 - Max Smirnov, 2016
// litegraph.js library (c) Javi Agenjo http://tamats.com

(function(){
/////////////
function flowObj()
{
	this.addInput("In","objectlist");
	this.addInput("Start","objectlist");
	this.addInput("End","objectlist");
	this.addOutput("Out","objectlist");
	this.properties = { straight:["Off","On","Off"], stretch:["On","On","Off"],flip_normal:["Off","On","Off"],rigid:["Off","On","Off"]};
}

flowObj.title = "flowObj";
flowObj.desc = "flowObj";

flowObj.prototype.onExecute = function()
{
	var inObj = this.getInputData(0, moi.geometryDatabase.createObjectList());
	var baseObj = this.getInputData(1, moi.geometryDatabase.createObjectList());
	var targetObj = this.getInputData(2, moi.geometryDatabase.createObjectList());
	var outObj = moi.geometryDatabase.createObjectList();
	if( inObj.length > 0 && baseObj.length > 0 && targetObj.length > 0)
	{ 

        if(baseObj.item(0).type===3 && targetObj.item(0).type===3){
            if(baseObj.item(0).getFaces().length === 1 && targetObj.item(0).getFaces().length ===1) {           //                 0       1                  2               3                   4                          5                              6    7    8     9                  10                       11  12
            outObj = factory ('flow', inObj, baseObj.item(0), targetObj.item(0), false , this.properties.stretch[0]==="On", this.properties.rigid[0]==="On", null, null, null,null,this.properties.flip_normal[0]==="On", false,true);//this.properties.cap_ends[0] === "On",null,null,this.properties.profiles[0],this.properties.numPts);	


            }
        }
        if((baseObj.item(0).type===1||baseObj.item(0).type===2) && (targetObj.item(0).type===1 || targetObj.item(0).type===2)){
            outObj = factory ('flow', inObj, baseObj.item(0), targetObj.item(0), false , this.properties.stretch[0]==="On", this.properties.rigid[0]==="On", null, null, null,null,this.properties.flip_normal[0]==="On", false,true);
            }
        }
        this.setOutputData(0, outObj);
}
LiteGraph.registerNodeType("Transform2/flowObj", flowObj);
////////////
function mflowObj()
{
	this.addInput("In","objectlist");
	this.addInput("Start","objectlist");
	this.addInput("End","objectlist");
	this.addOutput("Out","objectlist");
	this.properties = {mode: ["Long", "Long", "Short"], straight:["Off","On","Off"], stretch:["On","On","Off"],flip_normal:["Off","On","Off"],rigid:["Off","On","Off"]};
}

mflowObj.title = "mflowObj";
mflowObj.desc = "mflowObj";

mflowObj.prototype.onExecute = function()
{

        var data = this.processInOut(this.properties.mode[0], this.multiProcess, null, null, null);
    
        this.setOutputData(0, data.outputs[0]);


}

    mflowObj.prototype.multiProcess = function (inObj, baseObj, targetObj)
    {        var out = [];
    if( inObj.length > 0 && baseObj.length > 0 && targetObj.length > 0)
	{ 

        if(baseObj.item(0).type===3 && targetObj.item(0).type===3){
            if(baseObj.item(0).getFaces().length === 1 && targetObj.item(0).getFaces().length ===1) {           //                 0       1                  2               3                   4                          5                              6    7    8     9                  10                       11  12
            out[0] = factory ('flow', inObj, baseObj.item(0), targetObj.item(0), false , this.properties.stretch[0]==="On", this.properties.rigid[0]==="On", null, null, null,null,this.properties.flip_normal[0]==="On", false,true);//this.properties.cap_ends[0] === "On",null,null,this.properties.profiles[0],this.properties.numPts);	


            }
        }
        if((baseObj.item(0).type===1||baseObj.item(0).type===2) && (targetObj.item(0).type===1 || targetObj.item(0).type===2)){
            out[0] = factory ('flow', inObj, baseObj.item(0), targetObj.item(0), false , this.properties.stretch[0]==="On", this.properties.rigid[0]==="On", null, null, null,null,this.properties.flip_normal[0]==="On", false,true);
            }
        }
return out;
}
LiteGraph.registerNodeType("Transform2/mflowObj", mflowObj);

// ########### end movObj ############
////////////
    function stereoProject()
    {
        this.addInput("Curves", "objectlist");
        this.addInput("Radius", "numarray");
        this.addOutput("Out", "objectlist");
        this.properties = {mode: ["Long", "Long", "Short"], radius: [1], samples: 100};
    }

     stereoProject.title = "stereoProject";
     stereoProject.desc = "stereoProject";

     stereoProject.prototype.onExecute = function ()
    {
        var data = this.processInOut(this.properties.mode[0], this.multiProcess, null, this.properties.radius);
        this.properties.radius = data.inputs[1];
        this.setOutputData(0, data.outputs[0]);
    }

     stereoProject.prototype.multiProcess = function (inObj, R)
    {
        var out = [];
        if (inObj.length > 0)
        {
            var i, newPts=[];

            if (inObj.item(0).type === 1 || inObj.item(0).type === 2) {
                var startPt = inObj.item(0).getStartPt();
                var startPtObject = factory('point', startPt);
                /// creating a pointarray on the curve
                var crvPts = factory('arraycurve', startPtObject, inObj.item(0), 'NumItems', this.properties.samples);
                var crvPtsLen = crvPts.length;
                var lambda, p, q, div, x, y;

                x = startPt.x;
                y = startPt.y;
                div = (x * x + y * y + 4 * R * R);
                p = - (2 * x * x + 2 * y * y + 4 * R * R) / div;
                q = (x * x + y * y) / div;
                lambda = -p / 2 - Math.sqrt((p * p / 4 - q));

                var Z = moi.VectorMath.createPoint(0, 0, 2 * R);
                var U = substrVec(Z,startPt);
                newPts.push(addVec(scaleVec(U, lambda),startPt));

                for (i = 0; i < crvPtsLen; i++) {
                    U = substrVec(Z,crvPts.item(i).pt);
                    x = crvPts.item(i).pt.x;
                    y = crvPts.item(i).pt.y;
                    div = (x * x + y * y + 4 * R * R);
                    p = - (2 * x * x + 2 * y * y + 4 * R * R) / div;
                    q = (x * x + y * y) / div;
                    lambda = -p / 2 - Math.sqrt((p * p / 4 - q));
                    newPts.push(addVec(scaleVec(U, lambda),crvPts.item(i).pt));
//                    moi.ui.alert(lambda);

                }
                var fac = moi.command.createFactory( 'interpcurve' );
                var ln=newPts.length;
                for (i = 0; i<ln; ++i)
                {
                    fac.createInput('point');
		    fac.setInput(fac.numInputs - 1, newPts[i]);
                }
                out[0] = fac.calculate();
                fac.cancel();
                
            }
        }
        return out;
    }
LiteGraph.registerNodeType("Transform2/stereoProject", stereoProject);
// ########### end Loxodrome ############
function Mirror()
{
	this.addInput("Objects","objectlist");
	this.addInput("MirrorFrame","pointarray");
	this.addOutput("Out","objectlist");
	this.properties = {mode:["Long","Long","Long+","Short","Short+"]};
}

Mirror.title = "Mirror";
Mirror.desc = "Mirror objects";

Mirror.prototype.onExecute = function()
{       
	var data = this.processInOut(this.properties.mode[0], this.multiProcess, null, null);
	this.setOutputData(0, data.outputs[0]);
}

Mirror.prototype.multiProcess = function(obj,frm)
{         var out = [];
        var frame=frm.getFrame(0);
        var pt=frame.evaluate(1,0,0);
	out[0]=factory('mirror', obj, frame, pt, false);
        return out;
}
LiteGraph.registerNodeType("Transform2/Mirror", Mirror);
////////////////////
function Twist()
{
	this.addInput("Objects","objectlist");
	this.addInput("Start Axis","pointarray");
	this.addInput("End Axis","pointarray");
	this.addInput("Angle","numarray");
	this.addInput("Ease in","numarray");
	this.addInput("Ease out","numarray");
	this.addOutput("Out","objectlist");
	this.properties = {mode:["Long","Long","Long+","Short","Short+"],angle:[0],ease_in:[0.0],ease_out:[0.0]};
}

Twist.title = "Twist";
Twist.desc = "Twist objects";

Twist.prototype.onExecute = function()
{       
	var data = this.processInOut(this.properties.mode[0], this.multiProcess,null, null, null,this.properties.angle,this.properties.ease_in,this.properties.ease_out);
        this.properties.angle = data.inputs[3];
        this.properties.ease_in = data.inputs[4];
        this.properties.ease_out = data.inputs[5];
    this.setOutputData(0, data.outputs[0]);
}

Twist.prototype.multiProcess = function(obj,pts1,pts2,a,e_i,e_o)
{         var out = [];
        var p1=pts1.getPoint(0);
        var p2=pts2.getPoint(0);
	out[0]=factory('twist', obj, p1, p2, a,true, e_i, e_o);
        return out;
}
LiteGraph.registerNodeType("Transform2/Twist", Twist);

////////////////////
})();