// MoI Nodeedit
// Basic nodes v.0.85 - Max Smirnov, 2016
// litegraph.js library (c) Javi Agenjo http://tamats.com

(function () {

    function bVec()
    {
        var pt0 = moi.VectorMath.createPoint(0, 0, 0);
        var pt1 = moi.VectorMath.createPoint(0, 0, 1);
        var cp = moi.vectorMath.createPoint(0, 0, 0.8);
        var xaxs = moi.vectorMath.createPoint(1, 0, 0);
        var yaxs = moi.vectorMath.createPoint(0, 1, 0); 
        var wcs = moi.VectorMath.createFrame(cp, xaxs, yaxs);
        var dV = factory('line', pt0, pt1);
        var cone = factory('cone', true, wcs, null, 0.05, wcs.evaluate(0, 0, 0.2));
        dV.addObject(cone.item(0));
        var vecStyle = moi.geometryDatabase.findStyle('bVector', true);
        vecStyle.color = (160) << 16 | (10) << 8 | (10);
        for (var i = 0; i < dV.length; i++) {
            dV.item(i).styleIndex = vecStyle.index;
//            moi.geometryDatabase.addObjects(dV);
            dV.item(i).hidden = true;
        }
        return dV;
    }
    
function removeVec(that)
    {	moi.geometryDatabase.removeObjects(that.tempvec);
	that.tempvec = moi.geometryDatabase.createObjectList();}
function createVec(that,tPt0, tPt1)
    {
        var bPt0 = moi.VectorMath.createPoint(0, 0, 0);
        var bPt1 = moi.VectorMath.createPoint(0, 0, 1);
        var vecRep = factory('orientlinetoline', that.bVec, bPt0, bPt1, tPt0, tPt1, null, 'scale, stretch')

        for(var i=0;i<vecRep.length;i++)that.tempvec.addObject(vecRep.item(i));
    }
    
function createColorVec(that,tPt0, tPt1,cIdx)
    {
        var bPt0 = moi.VectorMath.createPoint(0, 0, 0);
        var bPt1 = moi.VectorMath.createPoint(0, 0, 1);
        var vecRep = factory('orientlinetoline', that.bVec, bPt0, bPt1, tPt0, tPt1, null, 'scale, stretch')

        for(var i=0;i<vecRep.length;i++){vecRep.item(i).styleIndex = cIdx;that.tempvec.addObject(vecRep.item(i));}
    }
function displayVec(that){moi.geometryDatabase.addObjects(that.tempvec);}
function applyVec(that){var i;for(i=0;i<that.tempvec.length;i++)that.tempvec.name="";moi.geometryDatabase.addObjects(that.tempvec);}

// vector convention in data of pointarray vector components{[0]=x,[1]=y,[2]=z},basepoint{[3]=x,[4]=y,[5]=z},[6]=homogenous
    function vector()
    {
//	this.minsize = [100, 0];
        this.addInput("X", "numarray");
        this.addInput("Y", "numarray");
        this.addInput("Z", "numarray");
        this.addInput("Pt", "pointarray");
        this.addOutput("Point", "pointarray");
        this.internal = {name: ""};
        this.bVec=moi.geometryDatabase.createObjectList();
        this.tempvec=moi.geometryDatabase.createObjectList();
        this.properties = {axissys: ["Global", "Global", "Local"], mode: ["Long", "Long", "Short"], x: [1], y: [0], z: [0]/*,h:[0]*/, visible: ["Yes", "Yes", "No"]};

    }

    vector.title = "Vector";
    vector.desc = "Vector";

    vector.prototype.onAdded = function (){this.bVec=bVec();}
    vector.prototype.onRemoved = function () {removeVec(this);}
    vector.prototype.onPropertyChange = function (){removeVec(this);}
    vector.prototype.onClear = function(){removeVec(this);}
    vector.prototype.onApply = function(){applyVec(this);}
    vector.prototype.onExecute = function ()
    {
        removeVec(this);
        var data = this.processInOut(this.properties.mode[0], this.multiProcess, this.properties.x, this.properties.y, this.properties.z, null/*,this.properties.h */);
        this.properties.x = data.inputs[0];
        this.properties.y = data.inputs[1];
        this.properties.z = data.inputs[2];
        this.setOutputData(0, data.outputs[0]);
        displayVec(this);
    }

    vector.prototype.multiProcess = function (x, y, z, bPt/*,h*/)
    {
        var out = [], vsPt;
        out[0] = new pointArray(false);
        if (bPt.data[6] === 1) { // a point
            vsPt = bPt.getPoint(0);
        } else { //its a vector no eval of local!!
            //this.properties.axissys[0] = "Global";
            vsPt = moi.VectorMath.createPoint(bPt.data[0] + bPt.data[3], bPt.data[1] + bPt.data[4], bPt.data[2] + bPt.data[5])
        }
//        if (bPt === null)
//            bPt = new pointArray(true);

        if (this.properties.axissys[0] === "Global") {
            var vePt = moi.VectorMath.createPoint(vsPt.x + x, vsPt.y + y, vsPt.z + z);

            out[0].push(x, y, z, vsPt.x, vsPt.y, vsPt.z, -1);
            if (this.properties.visible[0] === "Yes") createVec(this, vsPt, vePt);
        } 
            if (this.properties.axissys[0] === "Local" && bPt.data[6] === 1){
            var localVec = [];
            var localFrm = bPt.getFrame(0);

            localVec.push(moi.VectorMath.createPoint(x + localFrm.origin.x, y + localFrm.origin.y, z + localFrm.origin.z));
            var globalFrm = createWCS();
            var globalVec = transformPoints(localVec, localFrm, globalFrm);

            var vePt = moi.VectorMath.createPoint(vsPt.x + globalVec[0].x, vsPt.y + globalVec[0].y, vsPt.z + globalVec[0].z);
            if (this.properties.visible[0] === "Yes") {createVec(this, vsPt, vePt);}

            out[0].push(globalVec[0].x, globalVec[0].y, globalVec[0].z, vsPt.x, vsPt.y, vsPt.z, -1);
        }

        return out;
    }

    LiteGraph.registerNodeType("vector/vector", vector);

    function addVector()
    {
        this.addInput("a", "pointarray");
        this.addInput("b", "pointarray");
        this.addOutput("Point", "pointarray");
        this.internal = {name: ""};
        this.properties = { mode: ["Long", "Long", "Short"], visible: ["Yes", "Yes", "No"]};
        this.bVec=moi.geometryDatabase.createObjectList();
        this.tempvec=moi.geometryDatabase.createObjectList();
    }

    addVector.title = "addVector";
    addVector.desc = "addVector";

    addVector.prototype.onAdded = function (){this.bVec=bVec();}
    addVector.prototype.onRemoved = function () {removeVec(this);}
    addVector.prototype.onPropertyChange = function (){removeVec(this);}
    addVector.prototype.onClear = function(){removeVec(this);}
    addVector.prototype.onApply = function(){applyVec(this);}
    addVector.prototype.onExecute = function ()
    {
        removeVec(this);
        var data = this.processInOut(this.properties.mode[0], this.multiProcess, null, null);
        this.setOutputData(0, data.outputs[0]);
        displayVec(this);
    }

    addVector.prototype.multiProcess = function (ain, bin)
    {
        var out = [], a = ain.getPoint(0), b = bin.getPoint(0), vsPt;
        if (ain.data[6] === 1) { // a point
            vsPt = moi.VectorMath.createPoint(0,0,0);
        } else {
            vsPt = moi.VectorMath.createPoint(ain.data[3], ain.data[4],  ain.data[5]);
        }
        var c= addVec(a, b);
        var vePt = addVec(c,vsPt);
        out[0] = new pointArray(false);
            out[0].push(c.x, c.y, c.z, vsPt.x,vsPt.y,vsPt.z, -1);
            if (this.properties.visible[0] === "Yes") createVec(this,vsPt, vePt);
        return out;
    }

    LiteGraph.registerNodeType("vector/addVector", addVector);
function substrVector()
    {
        this.addInput("a", "pointarray");
        this.addInput("b", "pointarray");
        this.addOutput("Point", "pointarray");
        this.internal = {name: ""};
        this.properties = { mode: ["Long", "Long", "Short"], visible: ["Yes", "Yes", "No"]};
        this.bVec=moi.geometryDatabase.createObjectList();
        this.tempvec=moi.geometryDatabase.createObjectList();
    }

    substrVector.title = "substrVector";
    substrVector.desc = "substrVector";

    substrVector.prototype.onAdded = function (){this.bVec=bVec();}
    substrVector.prototype.onRemoved = function () {removeVec(this);}
    substrVector.prototype.onPropertyChange = function (){removeVec(this);}
    substrVector.prototype.onClear = function(){removeVec(this);}
    substrVector.prototype.onApply = function(){applyVec(this);}
    substrVector.prototype.onExecute = function ()
    {
        removeVec(this);
        var data = this.processInOut(this.properties.mode[0], this.multiProcess, null, null);
        this.setOutputData(0, data.outputs[0]);
        displayVec(this);
    }

    substrVector.prototype.multiProcess = function (ain, bin)
    {
        var out = [], a = ain.getPoint(0), b = bin.getPoint(0), vsPt;
        if (ain.data[6] === 1) { // a point
            vsPt = moi.VectorMath.createPoint(0,0,0);
        } else {
            vsPt = moi.VectorMath.createPoint(ain.data[3], ain.data[4],  ain.data[5]);
        }
        var c= substrVec(a, b);
        var vePt = addVec(c,vsPt);
        out[0] = new pointArray(false);
            out[0].push(c.x, c.y, c.z, vsPt.x,vsPt.y,vsPt.z, -1);
            if (this.properties.visible[0] === "Yes") createVec(this,vsPt, vePt);
        return out;
    }

    LiteGraph.registerNodeType("vector/substrVector", substrVector);    
function dotProduct()
    {
        this.addInput("a", "pointarray");
        this.addInput("b", "pointarray");
        this.addOutput("|a||b|*cos<(ab)", "numarray");
        this.internal = {name: ""};
        this.properties = {mode: ["Long", "Long", "Short"]};

    }

    dotProduct.title = "dotProduct";
    dotProduct.desc = "dotProduct";

    dotProduct.prototype.onExecute = function ()
    {
        var data = this.processInOut(this.properties.mode[0], this.multiProcess, null, null);
        this.setOutputData(0, data.outputs[0]);
    }

    dotProduct.prototype.multiProcess = function (ain, bin)
    {
        var out = [], a = ain.getPoint(0), b = bin.getPoint(0), c;
        c=dotProd(a, b);
        out[0] = c;
        return out;
    }
    LiteGraph.registerNodeType("vector/dotProduct", dotProduct);

    function CrossProduct()
    {
        this.addInput("a", "pointarray");
        this.addInput("b", "pointarray");
        this.addOutput("Point", "pointarray");
        this.internal = {name: ""};
        this.properties = { mode: ["Long", "Long", "Short"], visible: ["Yes", "Yes", "No"]};
        this.bVec=moi.geometryDatabase.createObjectList();
        this.tempvec=moi.geometryDatabase.createObjectList();
    }

    CrossProduct.title = "CrossProduct";
    CrossProduct.desc = "CrossProduct";

    CrossProduct.prototype.onAdded = function (){this.bVec=bVec();}
    CrossProduct.prototype.onRemoved = function () {removeVec(this);}
    CrossProduct.prototype.onPropertyChange = function (){removeVec(this);}
    CrossProduct.prototype.onClear = function(){removeVec(this);}
    CrossProduct.prototype.onApply = function(){applyVec(this);}
    CrossProduct.prototype.onExecute = function ()
    {
        removeVec(this);
        var data = this.processInOut(this.properties.mode[0], this.multiProcess, null, null);
        this.setOutputData(0, data.outputs[0]);
        displayVec(this);
    }

    CrossProduct.prototype.multiProcess = function (ain, bin)
    {
        var out = [], a = ain.getPoint(0), b = bin.getPoint(0), vsPt;
        if (ain.data[6] === 1) { // a point
            vsPt = moi.VectorMath.createPoint(0,0,0);
        } else {
            vsPt = moi.VectorMath.createPoint(ain.data[3], ain.data[4],  ain.data[5]);
        }
        var c= crossProd(a, b);
        var vePt = addVec(c,vsPt);
        out[0] = new pointArray(false);
            out[0].push(c.x, c.y, c.z, vsPt.x,vsPt.y,vsPt.z, -1);
            if (this.properties.visible[0] === "Yes") createVec(this,vsPt, vePt);
        return out;
    }

    LiteGraph.registerNodeType("vector/CrossProduct", CrossProduct);
    
    function vecAngle()
    {
        this.addInput("a", "pointarray");
        this.addInput("b", "pointarray");
        this.addOutput("acos<(ab)", "numarray");
        this.internal = {name: ""};
        this.properties = {mode: ["Long", "Long", "Short"]};

    }

    vecAngle.title = "vecAngle";
    vecAngle.desc = "vecAngle";

    vecAngle.prototype.onExecute = function ()
    {
        var data = this.processInOut(this.properties.mode[0], this.multiProcess, null, null);
        this.setOutputData(0, data.outputs[0]);
    }

    vecAngle.prototype.multiProcess = function (ain, bin)
    {
        var out = [], a = ain.getPoint(0), b = bin.getPoint(0), c;
        c=180/Math.PI*calcAngle(a, b);
        out[0] = c;
        return out;
    }
    LiteGraph.registerNodeType("vector/vecAngle", vecAngle);
    
        function LinebyVec()
    {
        this.addInput("Dir", "pointarray");
        this.addInput("base", "pointarray");
        this.addInput("length", "numarray");
        this.addOutput("Point", "objectlist");
        this.internal = {name: ""};
        this.properties = { mode: ["Long", "Long", "Short"],length:[1]};

    }

    LinebyVec.title = "LinebyVec";
    LinebyVec.desc = "LinebyVec";

/*    LinebyVec.prototype.onAdded = function (){this.internal.name = getUID(6);}
    LinebyVec.prototype.onRemoved = function () {bVecDelete(this.internal.name);}
    LinebyVec.prototype.onPropertyChange = function (){bVecDelete(this.internal.name);}
    LinebyVec.prototype.onStart = function (){bVecDelete(this.internal.name);}
    LinebyVec.prototype.onStop = function (){bVecDelete(this.internal.name);}
*/
    LinebyVec.prototype.onExecute = function ()
    {
        var data = this.processInOut(this.properties.mode[0], this.multiProcess, null, null,this.properties.length);
        this.properties.length = data.inputs[2];
        this.setOutputData(0, data.outputs[0]);
    }

    LinebyVec.prototype.multiProcess = function (dir, base, length)
    {
        var out = [], v = dir.getPoint(0), bPt = base.getPoint(0), bPt;
        if (this.inputs[2].link === null && dir.data[6] !== 1)
        {
        bPt = moi.VectorMath.createPoint(dir.data[3], dir.data[4], dir.data[5]);
        }
        else{if (base.data[6] === 1) { // a point
            bPt = base.getPoint(0);
        } else {
            bPt = moi.VectorMath.createPoint(base.data[0]+base.data[3], base.data[1]+base.data[4],base.data[2]+base.data[5]);
        }
    }
        var nv = scaleVec(scaleVec(v, 1 / magnitude(v)),length);

        var LePt= addVec(bPt,nv);
        out[0] = factory('line',bPt,LePt);


        return out;
    }
       LiteGraph.registerNodeType("vector/LinebyVec", LinebyVec);
       
function MoveByVec()
{
	this.addInput("Objects","objectlist");
	this.addInput("vec","pointarray");
	this.addOutput("Out","objectlist");
	this.properties = {mode:["Long","Long","Long+","Short","Short+"]};
}

MoveByVec.title = "MoveByVec";
MoveByVec.desc = "MoveByVec";

MoveByVec.prototype.onExecute = function()
{
	var data = this.processInOut(this.properties.mode[0], this.multiProcess, null, null );

	this.setOutputData(0, data.outputs[0]);
}

MoveByVec.prototype.multiProcess = function(o, vec)
{
	return [factory('move', o, moi.VectorMath.createPoint(0,0,0), moi.VectorMath.createPoint(vec.data[0],vec.data[1],vec.data[2]), true )];
}
LiteGraph.registerNodeType("vector/MoveByVec", MoveByVec);

function rotateVec()
{
	this.addInput("Vec","pointarray");
	this.addInput("axis","pointarray");
	this.addInput("angle","numarray");
	this.addOutput("Out","pointarray");
//	this.addOutput("Frms","pointarray");
	this.properties = {mode:["Long","Long","Short"],angle:[0],visible: ["Yes", "Yes", "No"]};
        this.bVec=moi.geometryDatabase.createObjectList();
        this.tempvec=moi.geometryDatabase.createObjectList();
}

rotateVec.title = "rotateVec";
rotateVec.desc = "rotateVec";

    rotateVec.prototype.onAdded = function (){this.bVec=bVec();}
    rotateVec.prototype.onRemoved = function () {removeVec(this);}
    rotateVec.prototype.onPropertyChange = function (){removeVec(this);}
    rotateVec.prototype.onClear = function(){removeVec(this);}
    rotateVec.prototype.onApply = function(){applyVec(this);}
rotateVec.prototype.onExecute = function()
{       removeVec(this);
	var data = this.processInOut(this.properties.mode[0], this.multiProcess, null, null, this.properties.angle );
        this.properties.angle = data.inputs[2];
	this.setOutputData(0, data.outputs[0]);
//        this.setOutputData(1, data.outputs[1]);
                displayVec(this);
}

rotateVec.prototype.multiProcess = function(vin, axs, angle)
{       var wcs,out=[],vec,axsVec,bPt,axsPt;
            out[0] = new pointArray(false);
        vec=vin.getPoint(0);
        axsVec=axs.getPoint(0);
        bPt=moi.vectorMath.createPoint(vin.data[3],vin.data[4],vin.data[5]);
        axsPt=moi.vectorMath.createPoint(axs.data[3],axs.data[4],axs.data[5]);
        wcs=createWCS();
        var aVmag=magnitude(axsVec);
        if(aVmag>0){
        var rotVec = scaleVec(axsVec, 1 / aVmag);
            var dHNF = dotProd(rotVec, axsPt); //ScalarProd from startpoint and tangent( normal vector to get distance of Hesse normalform 
            var abs_dx_0 = Math.abs(rotVec.x);
            var abs_dy_0 = Math.abs(rotVec.y);
            var abs_dz_0 = Math.abs(rotVec.z);
            if (abs_dx_0 >= abs_dy_0 && abs_dx_0 >= abs_dz_0){var u_help = moi.VectorMath.createPoint(axsPt.x,axsPt.y + 1,axsPt.z);}
            if (abs_dy_0 > abs_dx_0 && abs_dy_0 >= abs_dz_0){var u_help = moi.VectorMath.createPoint(axsPt.x + 1,axsPt.y,axsPt.z);}
            if (abs_dz_0 > abs_dx_0 && abs_dz_0 > abs_dy_0){var u_help = moi.VectorMath.createPoint(axsPt.x + 1,axsPt.y,axsPt.z);}
            var uLambda = (-(rotVec.x * u_help.x + rotVec.y * u_help.y + rotVec.z * u_help.z) + dHNF) / (rotVec.x * rotVec.x + rotVec.y * rotVec.y + rotVec.z * rotVec.z);
            var dirU = moi.VectorMath.createPoint(u_help.x + uLambda * rotVec.x - axsPt.x,u_help.y + uLambda * rotVec.y - axsPt.y, u_help.z + uLambda * rotVec.z - axsPt.z);
            dirU=scaleVec(dirU,1/magnitude(dirU));
            var dirV = crossProd(rotVec, dirU);
            var rotFrame = moi.VectorMath.createFrame(axsPt, dirU, dirV);
            var vecPts=[];vecPts.push(bPt);vecPts.push(addVec(bPt,vec));
////////////////////////////////End Create Base Frame //////////////////////////////
var localPts=transformPoints(vecPts,rotFrame,wcs);
var rAngle=angle/180*Math.PI;
var dirUrot=moi.VectorMath.createPoint(Math.cos(-rAngle),Math.sin(-rAngle),0);
var dirVrot=moi.VectorMath.createPoint(Math.sin(rAngle),Math.cos(rAngle),0);
var bPtrot=moi.VectorMath.createPoint(0,0,0);
var helpFrame = moi.VectorMath.createFrame(bPtrot, dirUrot, dirVrot);
var rlPt=transformPoints(localPts,helpFrame, wcs);
var rotatedPts=[];
rotatedPts.push(addVec(addVec(addVec(scaleVec(rotFrame.xaxis,rlPt[0].x),scaleVec(rotFrame.yaxis,rlPt[0].y)),scaleVec(rotFrame.zaxis,rlPt[0].z)),rotFrame.origin));
rotatedPts.push(addVec(addVec(addVec(scaleVec(rotFrame.xaxis,rlPt[1].x),scaleVec(rotFrame.yaxis,rlPt[1].y)),scaleVec(rotFrame.zaxis,rlPt[1].z)),rotFrame.origin));
if (this.properties.visible[0] === "Yes") createVec(this,rotatedPts[0], rotatedPts[1]);
out[0].push(rotatedPts[1].x-rotatedPts[0].x, rotatedPts[1].y-rotatedPts[0].y,rotatedPts[1].z-rotatedPts[0].z, rotatedPts[0].x,rotatedPts[0].y,rotatedPts[0].z, -1);
        }
        return out;
}
LiteGraph.registerNodeType("vector/rotateVec", rotateVec);

function colorVec()
{
	this.addInput("vecs","pointarray");
//	this.addOutput("Out","objectlist");
	this.properties = {visible: ["Yes", "Yes", "No"]};
        this.bVec=moi.geometryDatabase.createObjectList();
        this.tempvec=moi.geometryDatabase.createObjectList();
}

colorVec.title = "colorVec";
colorVec.desc = "colorVec";
    colorVec.prototype.onAdded = function (){this.rbID = createRainbow();this.bVec=bVec();}
    colorVec.prototype.onRemoved = function () {removeVec(this);}
    colorVec.prototype.onPropertyChange = function (){removeVec(this);}
    colorVec.prototype.onClear = function(){removeVec(this);}
    colorVec.prototype.onApply = function()
    {   if (this.properties.visible[0] === "No"){
    	moi.geometryDatabase.removeObjects(this.tempvec);
	this.tempvec = moi.geometryDatabase.createObjectList();
    }
    }

colorVec.prototype.onExecute = function()
{       removeVec(this);
    var i,n,vec,mags=[],mmin,mmax,elem,vsPts=[],vePts=[];
        if(this.inputs[0].link !== null){
        var vecs = this.getInputData(0, "pointarray");
        var vecslen=vecs.getLength();
//        mags.push(magnitude(moi.VectorMath.createPoint(vecs.data[0],vecs.data[1],vecs.data[2])));
        mmin=magnitude(moi.VectorMath.createPoint(vecs.data[0],vecs.data[1],vecs.data[2]));
        mmax=mmin;
    for(i=0;i<vecslen;i++){
        elem=vecs.getElement(i);
        vec=moi.VectorMath.createPoint(elem.data[0],elem.data[1],elem.data[2]);
        vsPts.push(moi.VectorMath.createPoint(elem.data[3],elem.data[4],elem.data[5]));
        vePts.push(addVec(vsPts[i],vec));
            mags.push(magnitude(vec));
         if(mags[i]>mmax)mmax=mags[i];
         if(mags[i]<mmin)mmin=mags[i];
        }
        
        for (n = 0; n < vecslen; n++)
        {createColorVec(this, vsPts[n], vePts[n],this.rbID[Math.round(254 - (254 * (mags[n] - mmin) / (mmax - mmin)))]);
            
        }
        displayVec(this);
        }
//	this.setOutputData(0, out);
}

LiteGraph.registerNodeType("vector/colorVec", colorVec);

function VecMagn()
    {
        this.addInput("vecs", "pointarray");
        this.addOutput("length", "numarray");
    }

    VecMagn.title = "VecMagn";
    VecMagn.desc = "VecMagn";

    VecMagn.prototype.onExecute = function ()
    {   if(this.inputs[0].link !== null){
        var vec = this.getInputData(0, "pointarray");
        var out = [],veclen=vec.getLength(),i;
        for(i=0;i<veclen;i++){
        out.push(magnitude(vec.getPoint(i)));
        this.setOutputData(0, out);
        }
    }
}
    LiteGraph.registerNodeType("vector/VecMagn", VecMagn);
    
       
function PointDist()
{
	this.addInput("Pt1","pointarray");
	this.addInput("Pt2","pointarray");
	this.addOutput("Out","numarray");
	this.properties = {mode:["Long","Long","Short"]};
}

PointDist.title = "PointDist";
PointDist.desc = "PointDist";

PointDist.prototype.onExecute = function()
{
	var data = this.processInOut(this.properties.mode[0], this.multiProcess, null, null );

	this.setOutputData(0, data.outputs[0]);
}

PointDist.prototype.multiProcess = function(ptA1, ptA2)
{    var pt1 = moi.vectorMath.createPoint(ptA1.data[0],ptA1.data[1],ptA1.data[2]);
     var pt2 = moi.vectorMath.createPoint(ptA2.data[0],ptA2.data[1],ptA2.data[2]);  
	return [magnitude(substrVec(pt2,pt1))];
}
LiteGraph.registerNodeType("vector/PointDist", PointDist);
})();